<?php

	function ReencodeString($sText)
	{
		$sTemp="";
		$iTemp=0;
		for ($i=0; $i<strlen($sText); $i++)
		{
			$iTemp=ord(substr($sText, $i, 1));
			if (($iTemp>=192) and ($iTemp<=255))
			$sTemp=$sTemp."&#".($iTemp+1040-176).";";
		}
		return $sTemp;
	}

	function GetImageNameByCaptionName($sText)
	{
		$sTemp="";
		for ($i=0; $i<count($_SESSION["UserTypeArray"][2][1]); $i++)
		{
			if ($_SESSION["UserTypeArray"][2][1][$i]==$sText)
			$sTemp=$_SESSION["UserTypeArray"][2][3][$i];
		}
		return $sTemp;
	}

	function ShowEssence(&$imImage, $iImageWidth, $iImageHeight, $iEssenceNumber,
		$iEssencesCount, $iLineWidth, $rgbRectangleColor, $rgbTextColor, $sText, $fFont, $sEssenceImportance)
	{
		// 
		$iLeft=$iImageWidth/3;
		$iRight=2*$iImageWidth/3;
		$iEssenceBoxHeight=$iImageHeight/($iEssencesCount*2+1);
		$iBottom=$iImageHeight-(1+$iEssenceNumber*2)*$iEssenceBoxHeight;
		$iTop=$iBottom-$iEssenceBoxHeight;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		imagefilledrectangle($imImage, $iLeft+$iLineWidth, $iTop+$iLineWidth,
		$iRight-$iLineWidth, $iBottom-$iLineWidth, $rgbRectangleColor);
		// freetype
		$sTemp=iconv("windows-1251", "UTF-8", $sText);
		//  
		$aShowTextResult=imageTTFBBox(14, 0, "./FreeTimes.ttf", $sTemp);
		// 
		ImageTTFtext($imImage, 14, 0,
		$iLeft+($iRight-$iLeft)/2-($aShowTextResult[2]-$aShowTextResult[6])/2,
		$iTop+($iBottom-$iTop)/2+($aShowTextResult[3]-$aShowTextResult[7])/3,
		$rgbTextColor, "./FreeTimes.ttf", $sTemp);
		if (!($sEssenceImportance==''))
		{
			$sTemp=iconv("windows-1251", "UTF-8", $sEssenceImportance);
			//  
			$aShowTextResult=imageTTFBBox(10, 0, "./FreeTimes.ttf", $sTemp);
			// 
			ImageTTFtext($imImage, 10, 0,
				(2*$iImageWidth/3)-($aShowTextResult[2]-$aShowTextResult[6])-$iLineWidth*2,
				$iBottom+($aShowTextResult[7]-$aShowTextResult[3])/2,
				$rgbTextColor, "./FreeTimes.ttf", $sTemp);
		}
		/*
		// postscript
		//  
		$aShowTextResult=imagepsbbox(ReencodeString($sText), $fFont, 18);
		// 
		imagepstext($imImage, ReencodeString($sText), $fFont, 18, $rgbTextColor, $rgbRectangleColor,
		$iLeft+($iRight-$iLeft)/2-($aShowTextResult[2]-$aShowTextResult[6])/2,
		$iTop+($iBottom-$iTop)/2-($aShowTextResult[7]-$aShowTextResult[3])/2);
		*/
		/*
		//   
		$ifFont=imageloadfont("./Areal16.gdf");
		imagestring($imImage, $ifFont,
		$iLeft+($iRight-$iLeft)/2-(imagefontwidth($ifFont)*strlen($sText))/2,
		$iTop+($iBottom-$iTop)/2-(imagefontheight($ifFont))/2, $sText, $rgbTextColor);
		*/
		/*
		//   
		//   
		$imTextImage=imagecreatefrompng("./Images/".GetImageNameByCaptionName($sText).".png");
		//   
		imagecopy($imImage, $imTextImage,
		$iLeft+($iRight-$iLeft)/2-(imagesx($imTextImage))/2,
		$iTop+($iBottom-$iTop)/2-(imagesy($imTextImage))/2,
		0, 0, imagesx($imTextImage), imagesy($imTextImage));
		imagedestroy($imTextImage);
		*/
	}

	function ShowNormalPattern(&$imImage, $iImageWidth, $iImageHeight, $iEssenceFrom,
		$iEssenceTo, $iEssencesCount, $iLineWidth, $rgbTextColor, $iPatternNumber)
	{
		// 
		$iLeft=($iImageWidth-$iLineWidth)/2;
		$iRight=($iImageWidth+$iLineWidth)/2;
		$iEssenceBoxHeight=$iImageHeight/($iEssencesCount*2+1);
		$iTop=($iEssenceFrom*2)*$iEssenceBoxHeight;
		$iBottom=($iEssenceTo*2-1)*$iEssenceBoxHeight-$iLineWidth*4;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$aArrowPoints=array(
		$iLeft-$iLineWidth, $iBottom,
		$iRight+$iLineWidth, $iBottom,
		$iLeft+$iLineWidth/2, $iBottom+$iLineWidth*4,
		$iLeft-$iLineWidth, $iBottom);
		//   
		imagefilledpolygon($imImage, $aArrowPoints , 4, $rgbTextColor);
		//  
		$aShowTextResult=imageTTFBBox(10, 0, "./FreeTimes.ttf", $iPatternNumber);
		// 
		ImageTTFtext($imImage, 10, 0,
		$iLeft+($iRight-$iLeft)/2+$iLineWidth*5.5-($aShowTextResult[2]-$aShowTextResult[6])/2,
		$iBottom-$iLineWidth*3-($aShowTextResult[7]-$aShowTextResult[3]),
		$rgbTextColor, "./FreeTimes.ttf", $iPatternNumber);
	}

	function ShowSelfPattern(&$imImage, $iImageWidth, $iImageHeight, $iEssence,
		$iEssencesCount, $iLineWidth, $rgbTextColor, $iPatternNumber)
	{
		//   
		$iLeft=$iImageWidth/2-$iImageWidth/(3*4)-$iLineWidth/2;
		$iRight=$iImageWidth/2-$iImageWidth/(3*4)+$iLineWidth/2;
		$iEssenceBoxHeight=$iImageHeight/($iEssencesCount*2+1);
		$iTop=($iEssence*2)*$iEssenceBoxHeight;
		$iBottom=($iEssence*2+1/2)*$iEssenceBoxHeight;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$iLeft=$iImageWidth/2+$iImageWidth/(3*4)-$iLineWidth/2;
		$iRight=$iImageWidth/2+$iImageWidth/(3*4)+$iLineWidth/2;
		$iTop=($iEssence*2)*$iEssenceBoxHeight+$iLineWidth*4;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$iLeft=$iImageWidth/2-$iImageWidth/(3*4)-$iLineWidth/2;
		$iRight=$iImageWidth/2+$iImageWidth/(3*4)+$iLineWidth/2;
		$iTop=$iBottom-$iLineWidth;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$iLeft=$iImageWidth/2+$iImageWidth/(3*4)-$iLineWidth/2;
		$iRight=$iImageWidth/2+$iImageWidth/(3*4)+$iLineWidth/2;
		$iTop=($iEssence*2)*$iEssenceBoxHeight;
		$aArrowPoints=array(
		$iLeft-$iLineWidth, $iTop+$iLineWidth*4,
		$iRight+$iLineWidth, $iTop+$iLineWidth*4,
		$iLeft+$iLineWidth/2, $iTop,
		$iLeft-$iLineWidth, $iTop+$iLineWidth*4);
		//   
		imagefilledpolygon($imImage, $aArrowPoints , 4, $rgbTextColor);
		//  
		$aShowTextResult=imageTTFBBox(10, 0, "./FreeTimes.ttf", $iPatternNumber);
		// 
		ImageTTFtext($imImage, 10, 0,
		$iLeft+($iRight-$iLeft)/2+$iLineWidth*5-($aShowTextResult[2]-$aShowTextResult[6])/2,
		$iTop+$iLineWidth+($aShowTextResult[3]-$aShowTextResult[7]),
		$rgbTextColor, "./FreeTimes.ttf", $iPatternNumber);
	}

	function ShowDownPattern(&$imImage, $iImageWidth, $iImageHeight, $iEssenceFrom,
		$iEssenceTo, $iEssencesCount, $iLineWidth, $rgbTextColor, $iPatternNumber)
	{
		//   
		$iLeft=$iImageWidth/2-$iImageWidth/(3*2)+$iLineWidth-
		$iImageWidth*($iEssencesCount-$iEssenceFrom+1)/(3*$iEssencesCount);
		$iRight=$iImageWidth/2-$iImageWidth/(3*2);
		$iEssenceBoxHeight=$iImageHeight/($iEssencesCount*2+1);
		$iTop=($iEssenceFrom*2-1/4)*$iEssenceBoxHeight-$iLineWidth/2;
		$iBottom=($iEssenceFrom*2-1/4)*$iEssenceBoxHeight+$iLineWidth/2;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$iTop=($iEssenceTo*2-3/4)*$iEssenceBoxHeight-$iLineWidth/2;
		$iBottom=($iEssenceTo*2-3/4)*$iEssenceBoxHeight+$iLineWidth/2;
		$iRight=$iImageWidth/2-$iImageWidth/(3*2)-$iLineWidth*4;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$iRight=$iLeft+$iLineWidth;
		$iTop=($iEssenceFrom*2-1/4)*$iEssenceBoxHeight-$iLineWidth/2;
		$iBottom=($iEssenceTo*2-3/4)*$iEssenceBoxHeight+$iLineWidth/2;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$iLeft=$iImageWidth/2-$iImageWidth/(3*2)-$iLineWidth*4;
		$iTop=($iEssenceTo*2-3/4)*$iEssenceBoxHeight-$iLineWidth*1.5;
		$aArrowPoints=array(
		$iLeft, $iTop,
		$iLeft+$iLineWidth*4, $iTop+$iLineWidth*1.5,
		$iLeft, $iTop+$iLineWidth*3,
		$iLeft, $iTop);
		//   
		imagefilledpolygon($imImage, $aArrowPoints , 4, $rgbTextColor);
		//  
		$aShowTextResult=imageTTFBBox(10, 0, "./FreeTimes.ttf", $iPatternNumber);
		// 
		ImageTTFtext($imImage, 10, 0,
		$iLeft+$iLineWidth*3-($aShowTextResult[2]-$aShowTextResult[6]),
		$iTop-$iLineWidth*7-($aShowTextResult[7]-$aShowTextResult[3]),
		$rgbTextColor, "./FreeTimes.ttf", $iPatternNumber);
	}

	function ShowUpPattern(&$imImage, $iImageWidth, $iImageHeight, $iEssenceFrom,
		$iEssenceTo, $iEssencesCount, $iLineWidth, $rgbTextColor, $iPatternNumber)
	{
		//   
		$iLeft=$iImageWidth/2+$iImageWidth/(3*2);
		$iRight=$iImageWidth/2+$iImageWidth/(3*2)-$iLineWidth+
		$iImageWidth*($iEssencesCount-$iEssenceTo+1)/(3*$iEssencesCount);
		$iEssenceBoxHeight=$iImageHeight/($iEssencesCount*2+1);
		$iTop=($iEssenceFrom*2-3/4)*$iEssenceBoxHeight-$iLineWidth/2;
		$iBottom=($iEssenceFrom*2-3/4)*$iEssenceBoxHeight+$iLineWidth/2;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$iLeft=$iImageWidth/2+$iImageWidth/(3*2)+$iLineWidth*4;
		$iTop=($iEssenceTo*2-1/4)*$iEssenceBoxHeight-$iLineWidth/2;
		$iBottom=($iEssenceTo*2-1/4)*$iEssenceBoxHeight+$iLineWidth/2;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$iLeft=$iRight-$iLineWidth;
		$iBottom=($iEssenceFrom*2-3/4)*$iEssenceBoxHeight+$iLineWidth/2;
		$iTop=($iEssenceTo*2-1/4)*$iEssenceBoxHeight-$iLineWidth/2;
		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);
		//   
		$iLeft=$iImageWidth/2+$iImageWidth/(3*2);
		$iTop=($iEssenceTo*2-1/4)*$iEssenceBoxHeight;
		$aArrowPoints=array(
		$iLeft, $iTop,
		$iLeft+$iLineWidth*4, $iTop-$iLineWidth*1.5,
		$iLeft+$iLineWidth*4, $iTop+$iLineWidth*1.5,
		$iLeft, $iTop);
		//   
		imagefilledpolygon($imImage, $aArrowPoints , 4, $rgbTextColor);
		//  
		$aShowTextResult=imageTTFBBox(10, 0, "./FreeTimes.ttf", $iPatternNumber);
		// 
		ImageTTFtext($imImage, 10, 0,
		$iLeft+$iLineWidth*2,
		$iTop+$iLineWidth*8,
		$rgbTextColor, "./FreeTimes.ttf", $iPatternNumber);
	}

//	$_SESSION["UserTypeArray"]='';
//	$_SESSION["UserTypeArray"]=include("../GetUserTypeArray.php");
	$iImageWidth=400;
	$iImageHeight=660;
	$iLineWidth=2;
	// 
	$imImage=imagecreate($iImageWidth, $iImageHeight);
	//  
	//$fFont=imagepsloadfont("./FreeTimes.pfb");
	$fFont=0;
	//   (RGB), 
	$rgbImageColor=imagecolorallocate($imImage,255,255,255);
	//  , 
	$rgbTextColor=imagecolorallocate($imImage,10,10,10);
	//  , 
	$rgbRectangleColor=imagecolorallocate($imImage,255,255,255);
	// ,     
	$sText="";
	$iTemp=0;
	$iSecTemp=0;
	foreach ($_GET as $Temp)
	{
		if  ($Temp=="~")
		{
			$iTemp++;
			$iSecTemp=0;
		}
		else
		{
			if  ($iTemp==0)
			{
				$aEssences[$iSecTemp][0]=$Temp;
				$aEssences[$iSecTemp][1]='';
			}
			if ($iTemp==1)
				$aT[$iSecTemp][0]=$Temp;
			if ($iTemp==2)
				$aT[$iSecTemp][1]=$Temp;
			if ($iTemp==3)
				$aEssences[$iSecTemp][1]=$Temp;
			$iSecTemp++;
		}
	}

	// 
	for ($i=0; $i<(count($aEssences)); $i++)
	{
		ShowEssence($imImage, $iImageWidth, $iImageHeight, $i, count($aEssences),
			$iLineWidth, $rgbRectangleColor, $rgbTextColor, $aEssences[$i][0], $fFont, $aEssences[$i][1]);
	}
	// 
	for ($i=0; $i<(count($aT)); $i++)
	{
		if (($aT[$i][1]-$aT[$i][0])==1)
			ShowNormalPattern($imImage, $iImageWidth, $iImageHeight, $aT[$i][0],
				$aT[$i][1], count($aEssences), $iLineWidth, $rgbTextColor, $i+1);
		if ($aT[$i][1]==$aT[$i][0])
			ShowSelfPattern($imImage, $iImageWidth, $iImageHeight, $aT[$i][0],
				count($aEssences), $iLineWidth, $rgbTextColor, $i+1);
		if (($aT[$i][0]<$aT[$i][1])   and  (!(($aT[$i][1]-$aT[$i][0])==1)))
			ShowDownPattern($imImage, $iImageWidth, $iImageHeight, $aT[$i][0],
				$aT[$i][1], count($aEssences), $iLineWidth, $rgbTextColor, $i+1);
		if ($aT[$i][0]>$aT[$i][1])
			ShowUpPattern($imImage, $iImageWidth, $iImageHeight, $aT[$i][0],
			$aT[$i][1], count($aEssences), $iLineWidth, $rgbTextColor, $i+1);
	}
	//  
	imagepng($imImage);
	//imagePSFreeFont($fFont);
	imagedestroy($imImage);
?>
