<?php

	function ReencodeString($sText)
	{
		$sTemp="";
		$iTemp=0;
		for ($i=0; $i<strlen($sText); $i++)
		{
			$iTemp=ord(substr($sText, $i, 1));
			if (($iTemp>=192) and ($iTemp<=255))
			$sTemp=$sTemp."&#".($iTemp+1040-176).";";
		}
		return $sTemp;
	}

	function GetImageNameByCaptionName($sText)
	{
		$sTemp="";
		for ($i=0; $i<count($_SESSION["UserTypeArray"][2][1]); $i++)
		{
			if ($_SESSION["UserTypeArray"][2][1][$i]==$sText)
			$sTemp=$_SESSION["UserTypeArray"][2][3][$i];
		}
		return $sTemp;
	}

	function ShowEssence(&$imImage, $iImageWidth, $iImageHeight, $iEssenceNumber,
		$iEssencesCount, $rgbTextColor, $sText, $fFont)
	{
		// 
		$iLeft=$iImageWidth/3;
		$iRight=2*$iImageWidth/3;
		$iEssenceBoxHeight=$iImageHeight/($iEssencesCount*2+1);
		$iTop=(2+$iEssenceNumber*4)*$iEssenceBoxHeight;
		$iBottom=$iBottom+$iEssenceBoxHeight;
		// freetype
		$sTemp=iconv("windows-1251", "UTF-8", $sText);
		//  
		$aShowTextResult=imageTTFBBox(14, 0, "./FreeTimes.ttf", $sTemp);
		// 
		ImageTTFtext($imImage, 14, 0,
			$iLeft+($iRight-$iLeft)/2-($aShowTextResult[2]-$aShowTextResult[6])/2,
			$iTop+($iBottom-$iTop)/2+($aShowTextResult[3]-$aShowTextResult[7])/3,
			$rgbTextColor, "./FreeTimes.ttf", $sTemp);
	}

	function ShowCaption(&$imImage, $iImageWidth, $iImageHeight, $rgbTextColor, $sText, $fFont, $bRealOrIdeal)
	{
		// 
		if ($bRealOrIdeal)
		{
			$iLeft=$iImageWidth/30;
			$iRight=$iImageWidth/3-$iImageWidth/30;
		}
		else
		{
			$iLeft=$iImageWidth-$iImageWidth/3+$iImageWidth/30;
			$iRight=$iImageWidth-$iImageWidth/30;
		}

		// freetype
		$sTemp=iconv("windows-1251", "UTF-8", $sText);
		//  
		$aShowTextResult=imageTTFBBox(14, 0, "./FreeTimes.ttf", $sTemp);
		// 
		ImageTTFtext($imImage, 14, 0,
			$iLeft+($iRight-$iLeft)/2-($aShowTextResult[2]-$aShowTextResult[6])/2,
			$iImageHeight-($aShowTextResult[3]-$aShowTextResult[7]),
			$rgbTextColor, "./FreeTimes.ttf", $sTemp);
	}

	function ShowSelfPattern(&$imImage, $iImageWidth, $iImageHeight, $iEssenceNumber,
		$iEssencesCount, $iLineWidth, $rgbTextColor, $iImportance, $bRealOrIdeal)
	{
		if ($bRealOrIdeal)
		{
			$iLeft=$iImageWidth/30;
			$iRight=$iImageWidth/3-$iImageWidth/30;
		}
		else
		{
			$iLeft=$iImageWidth-$iImageWidth/3+$iImageWidth/30;
			$iRight=$iImageWidth-$iImageWidth/30;
		}

		$iEssenceBoxHeight=$iImageHeight/($iEssencesCount*2+1);
		$iTop=(1.5+$iEssenceNumber*2)*$iEssenceBoxHeight-$iLineWidth/2;
		$iBottom=$iTop+$iLineWidth;

		//  
		imagefilledrectangle($imImage, $iLeft, $iTop, $iRight, $iBottom, $rgbTextColor);

		//    
		$aArrowPoints=array(
			$iLeft, $iTop-$iLineWidth,
			$iLeft-$iLineWidth*4, $iTop+$iLineWidth*0.5,
			$iLeft, $iBottom+$iLineWidth,
			$iLeft, $iTop-$iLineWidth);

		//    
		imagefilledpolygon($imImage, $aArrowPoints , 4, $rgbTextColor);

		//    
		$aArrowPoints=array(
			$iRight, $iTop-$iLineWidth,
			$iRight+$iLineWidth*4, $iTop+$iLineWidth*0.5,
			$iRight, $iBottom+$iLineWidth,
			$iRight, $iTop-$iLineWidth);

		//    
		imagefilledpolygon($imImage, $aArrowPoints , 4, $rgbTextColor);

		//  
		$aShowTextResult=imageTTFBBox(10, 0, "./FreeTimes.ttf", $iImportance);

		// 
		ImageTTFtext($imImage, 10, 0,
			$iRight-$iLineWidth*2-($aShowTextResult[2]-$aShowTextResult[6])/2,
			$iTop+$iLineWidth-($aShowTextResult[3]-$aShowTextResult[7])/2,
			$rgbTextColor, "./FreeTimes.ttf", $iImportance);
	}

	function ShowDownPattern(&$imImage, $iImageWidth, $iImageHeight, $iEssenceFrom, $iEssenceTo,
		$iEssencesCount, $iLineWidth, $rgbTextColor, $iImportance, $bRealOrIdeal)
	{

		if ($bRealOrIdeal)
		{
			$iCenterLeft=$iImageWidth/6;
			$iCycleWidth=($iImageWidth/6)*($iEssenceTo-$iEssenceFrom);
		}
		else
		{
			$iCenterLeft=$iImageWidth-$iImageWidth/6;
			$iCycleWidth=($iImageWidth/6)*($iEssenceTo-$iEssenceFrom);
		}

		$iArcStart=90;
		$iArcEnd=270;

		$iEssenceBoxHeight=$iImageHeight/($iEssencesCount*2+1);
		$iTop=(1.5+$iEssenceFrom*2)*$iEssenceBoxHeight-$iLineWidth/2;
		$iBottom=(1.5+$iEssenceTo*2)*$iEssenceBoxHeight+$iLineWidth/2;

		// 
		imagearc($imImage, $iCenterLeft, ($iTop+$iBottom)/2, $iCycleWidth, ($iBottom-$iTop), $iArcStart, $iArcEnd, $rgbTextColor);
		imagearc($imImage, $iCenterLeft, ($iTop+$iBottom)/2, $iCycleWidth-$iLineWidth/2, ($iBottom-$iTop)-$iLineWidth/2, $iArcStart, $iArcEnd, $rgbTextColor);
		imagearc($imImage, $iCenterLeft, ($iTop+$iBottom)/2, $iCycleWidth+$iLineWidth/2, ($iBottom-$iTop)+$iLineWidth/2, $iArcStart, $iArcEnd, $rgbTextColor);

		//    
		$aArrowPoints=array(
			$iCenterLeft, $iBottom-$iLineWidth*2,
			$iCenterLeft+$iLineWidth*4, $iBottom-$iLineWidth*0.5,
			$iCenterLeft, $iBottom+$iLineWidth*1.5,
			$iCenterLeft, $iBottom-$iLineWidth*2);

		//    
		imagefilledpolygon($imImage, $aArrowPoints , 4, $rgbTextColor);

		//  
		$aShowTextResult=imageTTFBBox(10, 0, "./FreeTimes.ttf", $iImportance);

		// 
		ImageTTFtext($imImage, 10, 0,
			$iCenterLeft-$iLineWidth*5+($aShowTextResult[2]-$aShowTextResult[6])/2,
			$iBottom-$iLineWidth-($aShowTextResult[3]-$aShowTextResult[7])/2,
			$rgbTextColor, "./FreeTimes.ttf", $iImportance);
	}

	function ShowUpPattern(&$imImage, $iImageWidth, $iImageHeight, $iEssenceFrom, $iEssenceTo,
		$iEssencesCount, $iLineWidth, $rgbTextColor, $iImportance, $bRealOrIdeal)
	{

		if ($bRealOrIdeal)
		{
			$iCenterLeft=$iImageWidth/6;
			$iCycleWidth=($iImageWidth/6)*($iEssenceFrom-$iEssenceTo);
		}
		else
		{
			$iCenterLeft=$iImageWidth-$iImageWidth/6;
			$iCycleWidth=($iImageWidth/6)*($iEssenceFrom-$iEssenceTo);
		}

		$iArcStart=270;
		$iArcEnd=90;

		$iEssenceBoxHeight=$iImageHeight/($iEssencesCount*2+1);
		$iTop=(1.5+$iEssenceTo*2)*$iEssenceBoxHeight-$iLineWidth/2;
		$iBottom=(1.5+$iEssenceFrom*2)*$iEssenceBoxHeight+$iLineWidth/2;

		// 
		imagearc($imImage, $iCenterLeft, ($iTop+$iBottom)/2, $iCycleWidth, ($iBottom-$iTop), $iArcStart, $iArcEnd, $rgbTextColor);
		imagearc($imImage, $iCenterLeft, ($iTop+$iBottom)/2, $iCycleWidth-$iLineWidth/2, ($iBottom-$iTop)-$iLineWidth/2, $iArcStart, $iArcEnd, $rgbTextColor);
		imagearc($imImage, $iCenterLeft, ($iTop+$iBottom)/2, $iCycleWidth+$iLineWidth/2, ($iBottom-$iTop)+$iLineWidth/2, $iArcStart, $iArcEnd, $rgbTextColor);

		//    
		$aArrowPoints=array(
			$iCenterLeft, $iTop-$iLineWidth*1.5,
			$iCenterLeft-$iLineWidth*4, $iTop+$iLineWidth*0.5,
			$iCenterLeft, $iTop+$iLineWidth*2,
			$iCenterLeft, $iTop-$iLineWidth*1.5);

		//    
		imagefilledpolygon($imImage, $aArrowPoints , 4, $rgbTextColor);

		//  
		$aShowTextResult=imageTTFBBox(10, 0, "./FreeTimes.ttf", $iImportance);

		// 
		ImageTTFtext($imImage, 10, 0,
			$iCenterLeft+$iLineWidth+($aShowTextResult[2]-$aShowTextResult[6])/2,
			$iTop+$iLineWidth*2+($aShowTextResult[3]-$aShowTextResult[7]),
			$rgbTextColor, "./FreeTimes.ttf", $iImportance);
	}

	$iImageWidth=310;
	$iImageHeight=175;
	$iLineWidth=2;
	// 
	$imImage=imagecreate($iImageWidth, $iImageHeight);
	//  
	//$fFont=imagepsloadfont("./FreeTimes.pfb");
	//   (RGB), 
	$rgbImageColor=imagecolorallocate($imImage,255,255,255);
	//  , 
	$rgbTextColor=imagecolorallocate($imImage,10,10,10);
	// ,     
	$sText="";
	$iTemp=0;
	$iSecTemp=0;
	$iSet=0;
	$iCounter=0;
	foreach ($_GET as $Temp)
	{
		if  ($Temp=="~")
		{
			$iTemp++;
			$iSecTemp=0;
			$iSet=0;
			$iCounter=0;
		}
		else
		{
			if  ($iTemp==0)
			{
				$aCaptions[$iSecTemp]=$Temp;
			}
			if  ($iTemp==1)
			{
				$aEssences[$iSecTemp]=$Temp;
			}
			if ($iTemp==2)
			{
				$aRealTypes[$iCounter][$iSet]=$Temp;
				$iSet++;
				if ($iSet==3)
				{
					$iSet=0;
					$iCounter++;
				}
			}
			if ($iTemp==3)
			{
				$aIdealTypes[$iCounter][$iSet]=$Temp;
				$iSet++;
				if ($iSet==3)
				{
					$iSet=0;
					$iCounter++;
				}
			}
			$iSecTemp++;
		}
	}

	// 
	for ($i=0; $i<(count($aCaptions)); $i++)
	{
		ShowCaption($imImage, $iImageWidth, $iImageHeight, 
			$rgbTextColor, $aCaptions[$i], $fFont, ($i==0));
	}


	// 
	for ($i=0; $i<(count($aEssences)); $i++)
	{
		ShowEssence($imImage, $iImageWidth, $iImageHeight, $i, count($aEssences),
			$rgbTextColor, $aEssences[$i], $fFont);
	}

	// 
	for ($i=0; $i<(count($aEssences)); $i++)
	{
		if ($aRealTypes[$i][1]==$aRealTypes[$i][0])
			ShowSelfPattern($imImage, $iImageWidth, $iImageHeight, ($aRealTypes[$i][0]-1),
				count($aEssences), $iLineWidth, $rgbTextColor, $aRealTypes[$i][2], True);
		if ($aRealTypes[$i][1]>$aRealTypes[$i][0])
			ShowDownPattern($imImage, $iImageWidth, $iImageHeight, ($aRealTypes[$i][0]-1), ($aRealTypes[$i][1]-1),
				count($aEssences), $iLineWidth, $rgbTextColor, $aRealTypes[$i][2], True);
		if ($aRealTypes[$i][1]<$aRealTypes[$i][0])
			ShowUpPattern($imImage, $iImageWidth, $iImageHeight, ($aRealTypes[$i][0]-1), ($aRealTypes[$i][1]-1),
				count($aEssences), $iLineWidth, $rgbTextColor, $aRealTypes[$i][2], True);

		if ($aIdealTypes[$i][1]==$aIdealTypes[$i][0])
			ShowSelfPattern($imImage, $iImageWidth, $iImageHeight, ($aIdealTypes[$i][0]-1),
				count($aEssences), $iLineWidth, $rgbTextColor, $aIdealTypes[$i][2], False);
		if ($aIdealTypes[$i][1]>$aIdealTypes[$i][0])
			ShowDownPattern($imImage, $iImageWidth, $iImageHeight, ($aIdealTypes[$i][0]-1), ($aIdealTypes[$i][1]-1),
				count($aEssences), $iLineWidth, $rgbTextColor, $aIdealTypes[$i][2], False);
		if ($aIdealTypes[$i][1]<$aIdealTypes[$i][0])
			ShowUpPattern($imImage, $iImageWidth, $iImageHeight, ($aIdealTypes[$i][0]-1), ($aIdealTypes[$i][1]-1),
				count($aEssences), $iLineWidth, $rgbTextColor, $aIdealTypes[$i][2], False);

	}

	//  
	imagepng($imImage);
	imagePSFreeFont($fFont);
	imagedestroy($imImage);
?>
